stages:
  - test
  - unit-tests
  - build
  - deploy

include:
  - '/ci/build/build-webapp.gitlab-ci.yml'
  - '/ci/pages/deploy-webapp.gitlab-ci.yml'
  - template: Code-Quality.gitlab-ci.yml


#code_quality:
#  tags: [ saas-linux-large-amd64 ]
#  rules:
#    - if: $CI_COMMIT_BRANCH == "main"
#    - if: $CI_MERGE_REQUEST_IID

code_quality:
  tags: [ saas-linux-large-amd64 ]
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  artifacts:
    paths: [gl-code-quality-report.json, gl-code-quality-report.html]



.code_quality_html:
  tags: [ saas-linux-large-amd64 ]
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  extends: code_quality
  variables:
    REPORT_FORMAT: html
  artifacts:
    paths: [gl-code-quality-report.html]

  #rules:
  #  - if: $CI_PIPELINE_SOURCE == "merge_request_event" # Run code quality job in merge request pipelines
  #  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH      # Run code quality job in pipelines on the default branch (but not in other branch pipelines)
  #  - if: $CI_COMMIT_TAG                               # Run code quality job in pipelines for tags

do:unit:tests:
  image: node:15.1.0-slim
  tags: [ saas-linux-large-amd64 ]
  stage: unit-tests
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  before_script:
    - npm install -g mocha
    - npm install -g mocha-junit-reporter
  artifacts:
    reports:
      junit: test-results.xml
    paths: 
      - test-results.xml
    expire_in: 1 week
  script:
    - mocha tests.js --reporter mocha-junit-reporter
    - cat ./test-results.xml

# -----------------------------
# Buid the web-app
# -----------------------------
build-index:
  stage: build
  tags: [ saas-linux-large-amd64 ]
  # => define the build process (👀 /ci/build/build-webapp.gitlab-ci.yml)
  extends: .build-webapp
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID

# -----------------------------
# Deploy the web-app
# -----------------------------
pages:
  stage: deploy
  tags: [ saas-linux-large-amd64 ]
  # => define the deployment process (👀 /ci/pages/deploy-webapp.gitlab-ci.yml)
  extends: .deploy-webapp
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_NAME}
    url: $DYNAMIC_ENVIRONMENT_URL
    on_stop: remove-environment

# -----------------------------
# Undeploy the web-app
# -----------------------------
remove-environment:
  stage: deploy
  tags: [ saas-linux-large-amd64 ]
  rules:
    - if: $CI_MERGE_REQUEST_IID
      when: manual
    - if: $CI_COMMIT_BRANCH == "main"
      when: never
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_NAME}
    action: stop
  allow_failure: true
  script:
    - echo "web application deleted"
